#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <errno.h>

#include <sys/ioctl.h>
#include <net/if.h>

#define INTERFACE "eth0"

void
restore_flags (struct ifreq *interface, short old_flags)
{
  int s;
  s = socket (PF_PACKET, SOCK_RAW, 0);	/* Necessaire pour l'appel  ioctl */
  interface->ifr_flags = old_flags;
  if (ioctl (s, SIOCSIFFLAGS, interface) < 0)
    perror ("ioctl(SIOCSIFFLAGS)");
  close (s);
}

struct ifreq *
detect (short *old, short promisc, char *if_name)
{
  int s;
  struct ifreq *dev;
  dev = (struct ifreq *) malloc (sizeof (struct ifreq));
  memset (dev, 0, sizeof (struct ifreq));
  if (!dev)
  {
    perror ("malloc()");
    printf ("Can't allocate memory for the ifreq structure\n");
    return (NULL);
  }
  s = socket (PF_PACKET, SOCK_RAW, 0);	/* Necessaire pour l'appel  ioctl */
  strcpy (dev->ifr_name, if_name);
  if (s < 0)
  {
     perror ("socket()");
     return (NULL);
  }
  if (ioctl (s, SIOCGIFHWADDR, dev) < 0)
  {
    perror ("ioctl(SIOCGIFHWADDR)");
    return (NULL);
  }
  if (ioctl (s, SIOCGIFINDEX, dev) < 0)
    {
      perror ("ioctl(SIOCGIFINDEX)");
      return (NULL);
    }
  if (promisc)
    {
      if (ioctl (s, SIOCGIFFLAGS, dev) < 0)
	{
	  perror ("ioctl(SIOCGIFFLAGS)");
	  return (NULL);
	}
      *old = dev->ifr_flags;
			printf("Old flags: %i\n",dev->ifr_flags);
      dev->ifr_flags = dev->ifr_flags | IFF_PROMISC;
      if (ioctl (s, SIOCSIFFLAGS, dev) < 0)
	{
	  perror ("ioctl(SIOCSIFFLAGS)");
	  return (NULL);
	}
    }
  close (s);
  return (dev);
}
