/*To FIX: passage de l'interface  l'tat down sans raison */

#include "promisc.h"


int
print_info (struct sockaddr_ll *dst, char *buffer, int buffer_len,
	    args * argument)
{
  FILE *out = argument->output;
  int proto;
  /* On affiche les info  propos du protocole ARP */
  if ((ntohs (dst->sll_protocol) == ETH_P_ARP) )
    {
      int i;
      myarp *pkt = arp_parser (buffer);
      struct in_addr *ip1, *ip2;
      ip1 = (struct in_addr *) malloc (sizeof (struct in_addr));
      ip2 = (struct in_addr *) malloc (sizeof (struct in_addr));
      if (!ip1 || !ip2)
	  return (-1);
      /*fprintf(out,"debug: %s %s\n",pkt->proto_addr_src,pkt->proto_addr_dest);*/
      ip1->s_addr = strtol (pkt->proto_addr_src, NULL, 16);
      ip2->s_addr = strtol (pkt->proto_addr_dest, NULL, 16);
      fprintf (out, "ARP: ");
      fprintf (out, "%s(%s)",inet_ntoa (*ip1), pkt->ether_src);
      fprintf (out, " -> ");
      fprintf (out, "%s(%s)",inet_ntoa (*ip2),pkt->ether_dest);
      fprintf (out, " %s protocol: %s\n",arp_type (pkt->opcode),pkt->ether_proto);
      switch(argument->nivo_info)
      {
        case 1:
	  fprintf(out,"\n");
	  break;
	case 2:
	  for (i = 0; i < buffer_len; i++)
	    fprintf (out, "%02x ", (unsigned char) buffer[i]);
	  fprintf (out,"\n%i bytes\n\n", i);
	  break;
	case 3:
	  for (i = 0; i < buffer_len; i++)
	    fprintf (out, "%02x ", (unsigned char) buffer[i]);
	  fprintf (out,"\n%i bytes\n\n", i);
	  break;
	}
       /*free(pkt);	*/

    }
  else
    {
      myip *pktip = ip_parser(buffer);
      mytcp *pkttcp = NULL;
      myudp *pktudp = NULL;
      struct in_addr *ip1, *ip2;
      ip1 = (struct in_addr *) malloc(sizeof(struct in_addr));
      ip2 = (struct in_addr *) malloc(sizeof(struct in_addr));
      if(!ip1 || !ip2) return (-1);
      ip1->s_addr = strtol(pktip->ip_src,NULL,16);
      ip2->s_addr = strtol(pktip->ip_dest,NULL,16);
      /* Cas du protocole TCP */
      proto = strtol(pktip->proto,NULL,16);
      switch(proto)
      {
      case 6:
        pkttcp = tcp_parser(buffer);
	fprintf(out,"IP/TCP: %s:%li",inet_ntoa(*ip1),strtol(pkttcp->port_src,NULL,16));
	fprintf(out," -> %s:%li\n",inet_ntoa(*ip2),strtol(pkttcp->port_dest,NULL,16));
	break;
      case 17:
        pktudp = udp_parser(buffer);
	fprintf(out,"IP/UDP: %s:%li",inet_ntoa(*ip1),strtol(pktudp->port_src,NULL,16));
	fprintf(out," -> %s:%li\n",inet_ntoa(*ip2),strtol(pktudp->port_dest,NULL,16));
	break;
      case 1:
        fprintf(out,"IP/ICMP: %s -> %s\n",inet_ntoa(*ip1),inet_ntoa(*ip2));
	break;
      }
      if(argument->nivo_info >= 2)
      { 
	  /* IP header */
	  fprintf(out,"len: %li ttl: %li\n",strtol(pktip->len,NULL,16) * 4 ,strtol(pktip->ttl,NULL,16));
	  if(argument->nivo_info == 3)
	    fprintf(out,"Id: %s(%li)\n",pktip->id,strtol(pktip->id,NULL,16));
	  switch(proto)
	  {
	   case 6:
	      /* TCP header */
	      fprintf(out,"seq: %s acc: %s\n",pkttcp->sequence,pkttcp->accuse);
	      if(argument->nivo_info == 3)
	      {
		int i;
		fprintf(out,"fenetre: %s checksum: %s\n",pkttcp->fenetre,pkttcp->checksum);
	  	for (i = 0; i < buffer_len; i++)
	    	  fprintf (out, "%02x ", (unsigned char) buffer[i]);
	  	fprintf (out,"\n%i bytes\n\n", i);
 	      }
	      /*free(pkttcp);*/		
	      break;
	   case 17:
	      /* UDP header */
	      fprintf(out,"len: %li\n",strtol(pktudp->len,NULL,16));
	      if(argument->nivo_info == 3)
	      {
	        int i;
	        fprintf(out,"data: %s\n",pktudp->data);
	  	for (i = 0; i < buffer_len; i++)
	    	  fprintf (out, "%02x ", (unsigned char) buffer[i]);
	  	fprintf (out,"\n%i bytes\n\n", i);
	      }		
	      /*free(pktudp);*/	
	      break;
	   case 1:
	      fprintf(out,"le protocole ICMP n'est pas implment pour le moment\n");
	      break;
	  }  
	}    
	fprintf(out,"\n");
      }
      
  return 0;
}

/* Fonction Principale du sniffeur en mode texte */
/* TODO: Penser  utiliser la nouvelle fonction init en lieu et place du */
/* gros pav de code */
int
main (int argc, char **argv)
{
  int sock, i, len, temp;
  short old_flags;
  struct sockaddr_ll mypacket;
  struct ifreq *interface;
  char buffer[2048];
  args *argue;
  argue = parse_command_line (argc, argv);
  if (!argue)
    exit (-1);
  sock = socket (PF_PACKET, SOCK_RAW, htons (ETH_P_ALL));
  interface = detect (&old_flags, argue->promisc, argue->interface);
  if (!interface || sock < 0)
    myexit ("Detection de l'interface echoue\n");
  mypacket.sll_family = AF_INET;
  mypacket.sll_ifindex = interface->ifr_ifindex; /*My interface, for all : 0 */
  mypacket.sll_halen = 0;
  mypacket.sll_protocol = htons (ETH_P_ALL);
  memcpy (mypacket.sll_addr, interface->ifr_hwaddr.sa_data,
	  strlen (interface->ifr_hwaddr.sa_data));
  /* The following fields must be set to 0 for sending packet ****** */
  mypacket.sll_hatype = 0;	/* ARPHRD_ETHER;  See linux/if_arp.h  */
  mypacket.sll_pkttype = 0;	/* PACKET_BROADCAST;                  */
  /******************************************************************/
  i = 0;
	/* penser  faire evoluer le test de manire  pouvoir le faire  l'infini */
  while(i < argue->nb_packet)
    {
      temp =
	/* LE &mypacket est il bien utile ??? */
	recvfrom (sock, &buffer, 2048, 0, (struct sockaddr *) &mypacket,
		  &len);
      if (temp > 1);
      {
	if(filtre(buffer,argue))
	{
 	  print_info (&mypacket, buffer, temp, argue);
	  i++;
        }
      }
    }
	printf("Old Flags 2: %i\n",old_flags);
  if(argue->promisc)restore_flags (interface, old_flags);
  fclose(argue->output);
  return 0;
}
