#include <stdio.h>
#include <stdlib.h>
#include <string.h>		/* memcpy() */
#include <sys/ioctl.h>		/* Getting specs of the interface */
#include <sys/socket.h>

/************************* For using the packet socket ******************/
#include <features.h>		/* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>	/* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>	/* The L2 protocols */
#endif
/********************** End of the packet socket 's part *****************/

#include <net/if.h>		/* Getting specs of the interface */
//#include <linux/if_arp.h>             /* Struct arphdr and constants */
#include <netinet/in.h>		/* htons() .... */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <arpa/inet.h>

FILE *debug;

/* Structure gestion hard */
typedef struct {
	struct sockaddr_ll mypacket;
	short oldflags;
	struct ifreq *interface;
	int sock;
}my_interface;


/* Structure des infos protocoles */
typedef struct
{
  char *ether_dest;		
  char *ether_src;
  char *ether_proto;
  char *opcode;
  char *proto_addr_dest;
  char *proto_addr_src;
}
myarp;

typedef struct{
  char *type;
  char *code;
  char *checksum;
  char *data;
} myicmp;


typedef struct{
  char *version;
  char *let;
  char *tos;
  char *len;
  char *id;
  char *ttl;
  char *proto;
  char *ip_src;
  char *ip_dest;
} myip;

typedef struct
{
 char *port_src;
 char *port_dest;
 char *sequence;
 char *accuse;
 char *fenetre;
 char *checksum;
 char *data;
} mytcp; 

typedef struct
{
  char *port_src;
  char *port_dest;
  char *len;
  char *data;
} myudp;

/* structure des arguments de la lignes de commandes */
typedef struct 
{
  FILE *output;
  char *interface;
  int proto;
  int nivo_info;
  unsigned short int promisc;
  int nb_packet;
  struct filtered{
   unsigned long int ip;
   int port;
   int proto;
  }filtre;
} args;  
  

/* Fonction oriente Hardware */
void restore_flags (struct ifreq *interface, short old_flags);
struct ifreq *detect (short *old, short promisc,char *if_name);
int init(my_interface *itf, args *argue);


/* Fonction oriente dcodage de trame */
char *put_hex (char *src, int pos, int len,short int ip);

int print_info (struct sockaddr_ll *dst,char *buffer, int buffer_len, args *argument);
myarp *arp_parser (char *packet);
myip *ip_parser (char *packet);
mytcp *tcp_parser (char *packet);
myudp *udp_parser(char *packet);
myicmp * icmp_parser(char *packet);

/* Fonction de rsolution des diffrents id-numriques */
char *getprotobyid (char *id);
int getprotoid(char *name);
char *getpkttypebyid (int id);
char *arp_type(char *opcode);
char *icmp_type(char *code);

/* Fonctions diverses */
void myexit (char *message);
args *parse_command_line (int argc, char **argv);
args *args_default(void);
unsigned int filtre(unsigned char *packet,args *argue);


